
#ifndef _H_u_t60
#define _H_u_t60
/*
 * Copyright (c) 2008 - 2012, Andy Bierman, All Rights Reserved.
 * Copyright (c) 2012 - 2021, YumaWorks, Inc., All Rights Reserved.
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/**
 * @file u_t60.h
 * @brief User SIL header for module t60
 *

*** Generated by yangdump-sdk tomcat-integ-2021-08-07.18.36

<pre>

    User SIL header
    module t60
    revision 2021-08-08
    prefix t
    namespace http://netconfcentral.org/ns/t60
    Created: 2021-08-08T17:01:27Z
    CLI parameters:
        format uh
        indent 4
        module t60
        output u_t60.h
        sil-get2
        unified true
</pre>

 */

#include <xmlstring.h>

#include "procdefs.h"
#include "agt.h"
#include "agt_cb.h"
#include "dlq.h"
#include "ncxtypes.h"
#include "op.h"
#include "rpc.h"
#include "ses.h"
#include "status.h"
#include "val.h"
#include "y_t60.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * @addtogroup yang-library YANG Library
 *
 * Collection of modules supported by the server.
 * Generated by yangdump-sdk.
 */



/**
 * @addtogroup sil-t60 Module t60
 * @ingroup yang-library
 *
 * @{
 *
 * YANG instrumentation library.
 * Generated by yangdump-sdk.
 */



/* list /top/A */
typedef struct y_t_T_A_ {
    dlq_hdr_t qhdr;
    uint8 v_a;
    uint8 v_b;
    uint8 v_c;
    xmlChar *v_d;
} y_t_T_A;

/* container /top */
typedef struct y_t_T_top_ {
    dlq_hdr_t v_A;
} y_t_T_top;


/**
 * @brief Get database object callback for list A (getcb_fn2_t)\n
 * Path: list /top/A\n
 *
 * Fill in 'get2cb' response fields.
 *
 * @param get2cb GET2 control block for the callback.
 * @param k_t_a Local key leaf 'a' in list 'A'\n
 * Path: /t:top/t:A/t:a
 * @param a_fixed TRUE if this key is fixed in a getnext request.
 * @param a_present TRUE if this key is present and 'k_t_a' is valid.\n
 * FALSE to get first in a getnext request.
 * @param k_t_b Local key leaf 'b' in list 'A'\n
 * Path: /t:top/t:A/t:b
 * @param b_fixed TRUE if this key is fixed in a getnext request.
 * @param b_present TRUE if this key is present and 'k_t_b' is valid.\n
 * FALSE to get first in a getnext request.
 * @param k_t_c Local key leaf 'c' in list 'A'\n
 * Path: /t:top/t:A/t:c
 * @param c_fixed TRUE if this key is fixed in a getnext request.
 * @param c_present TRUE if this key is present and 'k_t_c' is valid.\n
 * FALSE to get first in a getnext request.
 * @return return status of the callback.
 */
extern status_t u_t_A_get (
    getcb_get2_t *get2cb,
    uint8 k_t_a,
    boolean a_fixed,
    boolean a_present,
    uint8 k_t_b,
    boolean b_fixed,
    boolean b_present,
    uint8 k_t_c,
    boolean c_fixed,
    boolean c_present);


/**
 * @brief Get database object callback for container top (getcb_fn2_t)\n
 * Path: container /top\n
 *
 * Fill in 'get2cb' response fields.
 *
 * @param get2cb GET2 control block for the callback.
 * @return return status of the callback.
 */
extern status_t u_t_top_get (
    getcb_get2_t *get2cb);


/**
 * @brief Phase 1: Initialize the t60 server instrumentation library.
 *
 * Called by server when module is loaded.
 *
 * @param modname requested module name to load
 * @param revision requested revision date of the module to load.
 * This may be NULL if the module has no revision statements.
 * @return return status. An error will cause the module load to fail.
 */
extern status_t u_t60_init (
    const xmlChar *modname,
    const xmlChar *revision);


/**
 * @brief Phase 2: Initialize the t60 server instrumentation library.
 *
 * SIL init phase 2: non-config data structures.
 * Called after running config is loaded.
 *
 * @return return status. An error will cause the
 * server initialization to fail.
 */
extern status_t u_t60_init2 (void);


/**
 * @brief Cleanup the t60 server instrumentation library.
 *
 * Called by server when module is unloaded.
 *
 */
extern void u_t60_cleanup (void);


 /** @} */

#ifdef __cplusplus
} /* end extern 'C' */
#endif

#endif
