
/*
 * Copyright (c) 2008 - 2012, Andy Bierman, All Rights Reserved.
 * Copyright (c) 2012 - 2021, YumaWorks, Inc., All Rights Reserved.
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/**
 * @file y_t60.c
 * @brief YumaPro SIL module for module t60
 *

*** Generated by yangdump-sdk tomcat-integ-2021-08-07.18.36

<pre>

    YumaPro SIL module
    module t60
    revision 2021-08-08
    prefix t
    namespace http://netconfcentral.org/ns/t60
    Created: 2021-08-08T17:01:27Z
    CLI parameters:
        format yc
        indent 4
        module t60
        output y_t60.c
        sil-get2
        unified true

  Short Name Mappings
    A = /top/A
    a = /top/A/a
    b = /top/A/b
    c = /top/A/c
    d = /top/A/d
    top = /top
</pre>

 */

#include <xmlstring.h>

#include "procdefs.h"
#include "agt.h"
#include "agt_action.h"
#include "agt_cb.h"
#include "agt_rpc.h"
#include "agt_sil_lib.h"
#include "agt_timer.h"
#include "agt_util.h"
#include "agt_val.h"
#include "cfg.h"
#include "dlq.h"
#include "getcb.h"
#include "ncx.h"
#include "ncx_feature.h"
#include "ncxmod.h"
#include "ncxtypes.h"
#include "obj.h"
#include "rpc.h"
#include "status.h"
#include "val.h"
#include "val_child.h"
#include "val_util.h"
#include "xml_val.h"
#include "u_t60.h"
#include "y_t60.h"


/**
 * @addtogroup yang-library YANG Library
 *
 * Collection of modules supported by the server.
 * Generated by yangdump-sdk.
 */



/**
 * @addtogroup sil-t60 Module t60
 * @ingroup yang-library
 *
 * @{
 *
 * YANG instrumentation library.
 * Generated by yangdump-sdk.
 */


/* module static variables */
static ncx_module_t *t60_mod;
static obj_template_t *top_obj;

/**
 * @brief Initialize module static variables
 *
 * Called by server when module is loaded.
 */
static void y_t_init_static_vars (void)
{
    t60_mod = NULL;
    top_obj = NULL;

} /* y_t_init_static_vars */


/**
 * @brief Get database object callback for list A (getcb_fn2_t)\n
 * Path: list /top/A\n
 *
 * Fill in 'get2cb' response fields.
 *
 * @param scb session control block making the request.
 * @param msg message in progress for this retrieval request.
 * @param get2cb GET2 control block for the callback.
 * @return return status of the callback.
 */
static status_t A_get (
    ses_cb_t *scb,
    xml_msg_hdr_t *msg,
    getcb_get2_t *get2cb)
{

    if (LOGDEBUG) {
        log_debug("\nEnter A_get");
    }

    (void)scb;
    (void)msg;

    val_value_t *keyval = NULL;

    /* local key t60:a */
    uint8 k_t_a = 0;
    boolean a_fixed = FALSE;
    boolean a_present = FALSE;
    keyval = getcb_find_key_lvl(get2cb,
        y_t_M_t,
        y_t_N_a,
        (uint32)3);
    if (keyval) {
        k_t_a = VAL_UINT8(keyval);
        a_fixed = VAL_IS_FIXED_VALUE(keyval);
        a_present = TRUE;
    }

    /* local key t60:b */
    uint8 k_t_b = 0;
    boolean b_fixed = FALSE;
    boolean b_present = FALSE;
    keyval = getcb_find_key_lvl(get2cb,
        y_t_M_t,
        y_t_N_b,
        (uint32)3);
    if (keyval) {
        k_t_b = VAL_UINT8(keyval);
        b_fixed = VAL_IS_FIXED_VALUE(keyval);
        b_present = TRUE;
    }

    /* local key t60:c */
    uint8 k_t_c = 0;
    boolean c_fixed = FALSE;
    boolean c_present = FALSE;
    keyval = getcb_find_key_lvl(get2cb,
        y_t_M_t,
        y_t_N_c,
        (uint32)3);
    if (keyval) {
        k_t_c = VAL_UINT8(keyval);
        c_fixed = VAL_IS_FIXED_VALUE(keyval);
        c_present = TRUE;
    }

    return u_t_A_get(
        get2cb,
        k_t_a,
        a_fixed,
        a_present,
        k_t_b,
        b_fixed,
        b_present,
        k_t_c,
        c_fixed,
        c_present);

} /* A_get */


/**
 * @brief Get database object callback for container top (getcb_fn2_t)\n
 * Path: container /top\n
 *
 * Fill in 'get2cb' response fields.
 *
 * @param scb session control block making the request.
 * @param msg message in progress for this retrieval request.
 * @param get2cb GET2 control block for the callback.
 * @return return status of the callback.
 */
static status_t top_get (
    ses_cb_t *scb,
    xml_msg_hdr_t *msg,
    getcb_get2_t *get2cb)
{

    if (LOGDEBUG) {
        log_debug("\nEnter top_get");
    }

    (void)scb;
    (void)msg;

    return u_t_top_get(get2cb);

} /* top_get */


/**
 * @brief Phase 1: Initialize the t60 server instrumentation library.
 *
 * Called by server when module is loaded.
 *
 * @param modname requested module name to load
 * @param revision requested revision date of the module to load.
 * This may be NULL if the module has no revision statements.
 * @return return status. An error will cause the module load to fail.
 */
status_t y_t60_init (
    const xmlChar *modname,
    const xmlChar *revision)
{
    status_t res = NO_ERR;

    if (LOGDEBUG) {
        log_debug("\nEnter y_t60_init");
    }


    y_t_init_static_vars();

    /* change if custom handling done */
    if (xml_strcmp(modname, y_t_M_t)) {
        return ERR_NCX_UNKNOWN_MODULE;
    }

    if (revision && xml_strcmp(revision, y_t_R_t)) {
        return ERR_NCX_WRONG_VERSION;
    }

    res = ncxmod_load_module(
        y_t_M_t,
        y_t_R_t,
        agt_get_savedevQ(),
        &t60_mod);
    if (res != NO_ERR) {
        return res;
    }

    top_obj = ncx_find_object(
        t60_mod,
        y_t_N_top);
    if (top_obj == NULL) {
        return ERR_NCX_DEF_NOT_FOUND;
    }

    res = agt_cb_register_get_callback(
        y_t_M_t,
        (const xmlChar *)"/t:top",
        y_t_R_t,
        top_get);
    if (res != NO_ERR) {
        return res;
    }

    res = agt_cb_register_get_callback(
        y_t_M_t,
        (const xmlChar *)"/t:top/t:A",
        y_t_R_t,
        A_get);
    if (res != NO_ERR) {
        return res;
    }

    res = u_t60_init(modname, revision);
    return res;

} /* y_t60_init */


/**
 * @brief Phase 2: Initialize the t60 server instrumentation library.
 *
 * SIL init phase 2: non-config data structures.
 * Called after running config is loaded.
 *
 * @return return status. An error will cause the
 * server initialization to fail.
 */
status_t y_t60_init2 (void)
{
    status_t res = NO_ERR;

    if (LOGDEBUG) {
        log_debug("\nEnter y_t60_init2");
    }


    res = u_t60_init2();

    return res;

} /* y_t60_init2 */


/**
 * @brief Cleanup the t60 server instrumentation library.
 *
 * Called by server when module is unloaded.
 *
 */
void y_t60_cleanup (void)
{

    if (LOGDEBUG) {
        log_debug("\nEnter y_t60_cleanup");
    }


    agt_cb_unregister_callbacks(
        y_t_M_t,
        (const xmlChar *)"/t:top");

    agt_cb_unregister_callbacks(
        y_t_M_t,
        (const xmlChar *)"/t:top/t:A");
    u_t60_cleanup();

} /* y_t60_cleanup */


 /** @} */

/* END SIL y_t60.c */
